MyAddon = LibStub("AceAddon-3.0"):NewAddon("Gearing Guide", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0")

AceGUI = LibStub("AceGUI-3.0")

local libS = LibStub:GetLibrary("AceSerializer-3.0")
local libC = LibStub:GetLibrary("LibCompress")
local libCE = libC:GetAddonEncodeTable()

local epgpEnable
local groupEnable
local masterlootEnable

myOptions = {
  name = "Global Options",
  type = "group",
  args = {
    enable = {
      name = "Enable Addon",
      desc = "Enables / Disables the addon",
      type = "toggle",
      set = function(info,val) if (val) then MyAddon:Enable() else MyAddon:Disable() end MyAddon.enabled = val end,
      get = function(info) return MyAddon.enabled end
    },
	group = {
      name = "Enable Groups",
      desc = "Enables / Disables the addon for groups",
      type = "toggle",
      set = function(info,val) MyAddon.db.profile.groupEnable = val end,
      get = function(info) return MyAddon.db.profile.groupEnable end
    },
	masterloot = {
      name = "Enable MasterLooter",
      desc = "Enables / Disables the addon for Master Looter tracking",
      type = "toggle",
      set = function(info,val) MyAddon.db.profile.masterlootEnable = val end,
      get = function(info) return MyAddon.db.profile.masterlootEnable end
    },
	epgp = {
      name = "Enable EPGP Prices",
      desc = "Enables / Disables the addon showing the EPGP Prices according to the EPGP wiki",
      type = "toggle",
      set = function(info,val) MyAddon.db.profile.epgpEnable = val end,
      get = function(info) return MyAddon.db.profile.epgpEnable end
    },
	wish = {
	  name = "Wish List",
	  desc = "Opens the Wish List, to set up the list of items to look out for",
	  type = "execute",
	  func = function() WishListFrame() end,
	},
	
	epgpprices = {
		name = "Custom Prices",
		type = "group",
		args = {
			customValues = {
				name = "Enable Custom Values",
				desc = "Enables / Disables the addon using Custom Values",
				type = "toggle",
				set = function(info,val) MyAddon.db.profile.inGuild = val end,
				get = function(info) return MyAddon.db.profile.inGuild end
			},
			customName = {
				name = "Enter Loot System Name",
				desc = "Enter the name of the Loot system you use with a Fixed Price System",
				type = "input",
				set = function(info,val) MyAddon.db.profile.system = val end,
				get = function(info) return MyAddon.db.profile.system end
			},
			values = {
				name = "Values",
				type = "group",
				args = {
					helm = {
						name = "Helmet Price",
						desc = "Input the custom Helmet Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.HelmGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.HelmGP) end
					},
					neck = {
						name = "Neck Price",
						desc = "Input the custom Neck Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.NeckGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.NeckGP) end
					},
					shoulder = {
						name = "Shoulders Price",
						desc = "Input the custom Shoulders Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.ShouldersGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.ShouldersGP) end
					},
					cloak = {
						name = "Cloak Price",
						desc = "Input the custom Cloak Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.CloakGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.CloakGP) end
					},
					chest = {
						name = "Chest Piece Price",
						desc = "Input the custom Chest Piece Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.ChestGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.ChestGP) end
					},
					wrist = {
						name = "Wrist Price",
						desc = "Input the custom Wrist Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.WristGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.WristGP) end
					},
					glove = {
						name = "Gloves Price",
						desc = "Input the custom Gloves Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.GlovesGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.GlovesGP) end
					},
					waist = {
						name = "Waist Price",
						desc = "Input the custom Waist Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.WaistGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.WaistGP) end
					},
					legs = {
						name = "Leg Piece Price",
						desc = "Input the custom Legs Piece Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.LegsGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.LegsGP) end
					},
					boots = {
						name = "Boots Price",
						desc = "Input the custom Boots Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.BootsGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.BootsGP) end
					},
					ring = {
						name = "Ring Price",
						desc = "Input the custom Ring Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.RingGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.RingGP) end
					},
					trinket = {
						name = "Trinket Price",
						desc = "Input the custom Trinket Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.TrinketGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.TrinketGP) end
					},
					mainhand = {
						name = "Mainhand Weapon Price",
						desc = "Input the custom Mainhand Weapon Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.MainhandGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.MainhandGP) end
					},
					offhand = {
						name = "Offhand Price",
						desc = "Input the custom Offhand (Weapons/Shields) Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.OffhandGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.OffhandGP) end
					},
					twohand = {
						name = "Two Handed Weapon Price",
						desc = "Input the custom Two Handed Weapon Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.WeaponGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.WeaponGP) end
					},
				},
			},
		},
	},
  }
}

local AceConfig = LibStub("AceConfig-3.0")
AceConfig:RegisterOptionsTable("Gearing Guide", myOptions)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Gearing Guide")

local frame
local slotID
local sName
local sLink
local iRarity
local iLevel
local dropppediLevel
local sType
local sSubType
local sEquip
local sTexture
local RsName
local RsLink
local RiRarity
local RiLevel
local RdropppediLevel
local RsType
local RsSubType
local RsEquip
local RsTexture
local statsTable = {}
local tablePrio = {}
local iEPGPCost
local primaryStat
local stats = {}
local comparing = false
local compareGroup
local typeOfItem
local typeOfItem1
local lootID
local isLockbox = false
local MLEPGPCost
local LootSystem
local droppedItems = {}
local droppedIDs = {}
local numberDrops = 0
local tab
local MLTablePrio = {}
local lineAdded = false
local MLsTexture
local isOpen = false
local wishText
local dropID
local classesTable = {}
local isRaidLooter = false

local defaults = {
  profile = {
	droppedItemLink = "",
	isOpen = false,
	inGuild = false,
	system = "EPGP",
	groupEnable = true,
	masterlootEnable = true,
	epgpEnable = false,
	point = "CENTER",
	relPoint = "CENTER",
	x = 0,
	y = 0,
		epgp = {
			HelmGP = 1,
			NeckGP = 0.55,
			ShouldersGP = 0.777,
			CloakGP = 0.55,
			ChestGP = 1,
			WristGP = 0.777,
			GlovesGP = 0.777,
			WaistGP = 0.777,
			LegsGP = 1,
			BootsGP = 0.777,
			RingGP = 0.55,
			TrinketGP = 0.7,
			MainhandGP = 0.42,
			OffhandGP = 0.55,
			WeaponGP = 1,
		},
		custom = {
			HelmGP = 2200,
			NeckGP = 1250,
			ShouldersGP = 1650,
			CloakGP = 1250,
			ChestGP = 2200,
			WristGP = 1250,
			GlovesGP = 1650,
			WaistGP = 1650,
			LegsGP = 2200,
			BootsGP = 1650,
			RingGP = 1250,
			TrinketGP = 1650,
			MainhandGP = 2450,
			OffhandGP = 950,
			WeaponGP = 3400,
		},
		wishlist = {
			items = {},
		},
	}
}

function MyAddon:OnInitialize()
	MyAddon.enabled = true
	local guildName = GetGuildInfo(UnitName("player"))
	droppedIDs = {}
	self.db = LibStub("AceDB-3.0"):New("GearingGuideDB1", defaults)
	
	MyAddon.db.profile.isOpen = false

	MyAddon:RegisterChatCommand("", "ChatCommand")
	
	--MyAddon:RegisterEvent("PLAYER_LOGIN", test)
end

	local LOOT_SELF_REGEX = gsub(LOOT_ITEM_SELF, "%%s", "(.+)")
	local LOOT_REGEX = gsub(LOOT_ITEM, "%%s", "(.+)")

function MyAddon:OnEnable()
	if (MyAddon.db.profile.groupEnable) then
		MyAddon:RegisterEvent("START_LOOT_ROLL")
	end
	if (MyAddon.db.profile.masterlootEnable) then		
		MyAddon:RegisterEvent("OPEN_MASTER_LOOT_LIST")
	end
	MyAddon:RegisterComm("LootingGuideNI")
	
	Pre_WoW_Rollonloot = RollOnLoot
	RollOnLoot = LootRoll
end

function MyAddon:ChatCommand(input)
	if not input or input:trim() == "" then
		LibStub("AceConfigDialog-3.0"):Open("Gearing Guide")
	elseif input == "enable" then
		MyAddon:Enable()
		MyAddon:Print("Gearing Guide is now Enabled")
	elseif input == "disable" then
		MyAddon:Disable()
		MyAddon:Print("Gearing Guide is now Disabled")
	end
end

function MyAddon.START_LOOT_ROLL(_,_,id)
	MLsTexture = nil 
	MLEPGPCost = nil
	local droppedItemID = GetLootRollItemLink(id)
	lootID = id		
	sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(droppedItemID)

	if (sType == "Armor" or sType == "Weapon" or (sType == "Miscellaneous" and sSubType == "Junk" and dropppediLevel > 69)) then
		local a, b = strsplit(" ", sName, 2)
		if (b == "Lockbox" or b == "Iron Lockbox") then
			isLockbox = true
		end
		if (isLockbox == false) then
			numberDrops = numberDrops + 1			
			table.insert(droppedIDs, droppedItemID)
			local i = tablelength(droppedItems)
			table.insert(droppedItems, {value = i, text = sName})
			ActivatePrint()
			tab:SelectTab(0)			
		else
			isLockbox = false
		end
	end	
end

function MyAddon.OPEN_MASTER_LOOT_LIST()
	local droppedItemID = GetLootSlotLink(LootFrame.selectedSlot)
	
	sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(droppedItemID)
	
	if (sType == "Armor" or sType == "Weapon" or (sType == "Miscellaneous" and sSubType == "Junk" and dropppediLevel > 69)) then
		local a, b = strsplit(" ", sName, 2)
		if (b == "Lockbox" or b == "Iron Lockbox") then
			isLockbox = true
		end
		if (isLockbox == false) then
			table.insert(droppedIDs, sLink)
			local i = tablelength(droppedItems)
			table.insert(droppedItems, {value = i, text = sName})
			isRaidLooter = true
			MyAddon.db.profile.droppedItemLink = droppedItemID
			ActivatePrint()
			tab:SelectTab(0)
			MyAddon:RegisterEvent("CHAT_MSG_LOOT")						
		else
			isLockbox = false
		end		
	else
		slotID = nil
	end	
end

local function OnTooltipSetItem(tooltip, ...)
	if (lineAdded == false) then
		local _, linkTool = tooltip:GetItem()

		if (IsEquippableItem(linkTool) ~= nil) then
			sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(linkTool)
			ToolTipScanner(true)
			PriorityTable()			
			stats = GetItemStats(sLink, statsTable)
			WorkoutPrimary()
			iLevel = dropppediLevel
			EquipPrio()
			sort(tablePrio, function(a,b) return a.prio > b.prio end)
			local setColorR = 0
			local setColorG = 0
			local setColorB = 0
			for _, v in ipairs(tablePrio) do				
				if (v.prio > 4) then
					if (v.prio > 13) then
						setColorR = 1.0
					elseif (v.prio == 13) then
						setColorR = 1.0
						setColorG = 0.2
					elseif (v.prio == 12) then
						setColorR = 1.0
						setColorG = 0.4
					elseif (v.prio == 11) then
						setColorR = 1.0
						setColorG = 0.6
					elseif (v.prio == 10) then
						setColorR = 1.0
						setColorG = 0.8
					elseif (v.prio == 9) then
						setColorR = 1.0
						setColorG = 1.0
					elseif (v.prio == 8) then
						setColorR = 0.2
						setColorG = 1.0
					elseif (v.prio == 7) then
						setColorG = 1.0					
						setColorB = 0.2
					elseif (v.prio == 6) then
						setColorG = 1.0
						setColorB = 0.4
					end

					if( setColorR == 0 and setColorG == 0 and setColorB == 0 ) then
						setColorR = 1
						setColorG = 1
						setColorB = 1
					end
					tooltip:AddLine("Gearing Guide: "..v.prio.." - "..v.spec.." "..v.class, setColorR, setColorG, setColorB)
				end
			end
			table.wipe(classesTable)
			table.wipe(stats)
			table.wipe(tablePrio)
			lineAdded = true
		end
	end
end

local function OnTooltipCleared(tooltip, ...)
   lineAdded = false
end

GameTooltip:HookScript("OnTooltipSetItem", OnTooltipSetItem)
GameTooltip:HookScript("OnTooltipCleared", OnTooltipCleared)

function LootRoll(Rollid, roll)
	if MyAddon.db.profile.isOpen then
		numberDrops = numberDrops - 1
		if (numberDrops == 0) then
			SaveFramePosition()
			MyAddon.db.profile.isOpen = false
			table.wipe(droppedIDs)
			table.wipe(droppedItems)
			 
			AceGUI:Release(frame)					
		end
	end
	Pre_WoW_Rollonloot(Rollid, roll)
end

function MyAddon:CHAT_MSG_LOOT(n, lootmsg)
    if MyAddon.db.profile.isOpen then
		local _, _, sPlayer, ditemlink = string.find(lootmsg, LOOT_REGEX)
		if not sPlayer then _, _, ditemlink = string.find(lootmsg, LOOT_SELF_REGEX) end
		if not ditemlink then return end
		if (ditemlink == MyAddon.db.profile.droppedItemLink) then
			SaveFramePosition()
			MyAddon.db.profile.isOpen = false
			table.wipe(droppedIDs)
			table.wipe(droppedItems)
			
			MLsTexture = nil
			MLEPGPCost = nil
			AceGUI:Release(frame)						
		end
	end
end

function test()
	local id = 89611		
	sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(id)
	
	if (sType == "Armor" or sType == "Weapon" or (sType == "Miscellaneous" and sSubType == "Junk" and dropppediLevel > 69)) then
		local a, b = strsplit(" ", sName, 2)
		if (b == "Lockbox" or b == "Iron Lockbox") then
			isLockbox = true
		end
		
		if (isLockbox == false) then
			table.insert(droppedIDs, sLink)
			local i = tablelength(droppedItems)
			table.insert(droppedItems, {value = i, text = sName})
			ActivatePrint()					
		else
			isLockbox = false
		end
	end
end

function MyAddon:OnCommReceived(prefix, message, distribution, sender)
	local playerName = UnitName("player")
	if (sender ~= playerName) then
		if (prefix == "LootingGuideNI") then
			local decode = libCE:Decode(message)
			local decompress, errMess = libC:Decompress(decode)
			
			if(not decompress) then
				MyAddon:Print("Error decompressing: " ..errMess)
				return
			end

			local success, final = libS:Deserialize(decompress)
			if(not success) then
				MyAddon:Print("Error deserializing: " ..final)
				return
			end

			local rTable
			LootSystem, MLEPGPCost, RsName, RsLink, RiRarity, RdILvl, RsType, RsSubType, RsEquip, RsTexture, rTable = strsplit("/", final)
			RdILvl = tonumber(RdILvl)
			sName, sLink, iRarity, dropppediLevel, sType, sSubType, sEquip, MLsTexture = RsName, RsLink, RiRarity, RdILvl, RsType, RsSubType, RsEquip, RsTexture

			local success, sTable = libS:Deserialize(rTable)
			if(not success) then
				MyAddon:Print("Error deserializing: " ..sTable)
				return
			end

			MLTablePrio = sTable
			MyAddon.db.profile.droppedItemLink = sLink
			table.insert(droppedIDs, MyAddon.db.profile.droppedItemLink)
			local i = tablelength(droppedItems)
			table.insert(droppedItems, {value = i, text = sName})
			ActivatePrint()
			tab:SelectTab(0)
			MyAddon:RegisterEvent("CHAT_MSG_LOOT")
		end
	end
end

function ActivatePrint()
	if (MyAddon.db.profile.isOpen ~= true) then
		MyAddon.db.profile.isOpen = true
				
		frame = AceGUI:Create("Frame")

		LoadFramePosition()

		frame:SetTitle("Gearing Guide")
		frame:SetCallback("OnClose", function(frame) SaveFramePosition() MyAddon.db.profile.isOpen = false table.wipe(droppedIDs) table.wipe(droppedItems) MLsTexture = nil MLEPGPCost = nil AceGUI:Release(frame) end)			
		frame:SetLayout("Fill")
		frame:SetWidth(250)
		frame:SetStatusText("v1.0.5 - MoP")
		local i = tablelength(droppedItems)
		i = i - 1
		local height = 375 + (18 * i)
		frame:SetHeight(height)
		frame:EnableResize(Hide)

		tab = AceGUI:Create("TabGroup")
		tab:SetLayout("Flow")
		tab:SetTabs(droppedItems)
		tab:SetCallback("OnGroupSelected", SelectGroup)
		tab:SelectTab(0)

		frame:AddChild(tab)	
	else
		local i = tablelength(droppedItems)
		i = i - 1
		local height = 375 + (18 * i)
		frame:SetHeight(height)
	end
end

function SelectGroup(container, event, group)
	container:ReleaseChildren()
	typeOfItem1 = nil
	SaveFramePosition()
	local index = group + 1
	if (comparing == false) then
		ItemSelect(droppedIDs[index])
		DrawGroup(container)
	else
		comparing = false
		ItemSelect(droppedIDs[index])
		MyAddon.db.profile.isOpen = false
		AceGUI:Release(frame)		
		ActivatePrint()
		tab:SelectTab(group)
	end	
end

function ItemSelect(id)
	if (MLsTexture == nil) then
		sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(id)
		PriorityTable()
		stats = GetItemStats(sLink, statsTable)
	else
		sName, sLink, iRarity, dropppediLevel, sType, sSubType, sEquip, MLsTexture = RsName, RsLink, RiRarity, RdILvl, RsType, RsSubType, RsEquip, RsTexture
	end
		
	MyAddon.db.profile.droppedItemLink = sLink
	ToolTipScanner(true)
end

function DrawGroup(container)	
	WorkOutEPGP()
		
	local itemGroup = AceGUI:Create("InlineGroup")
	itemGroup:SetTitle("Dropped Item")
	itemGroup:SetWidth(197)
	itemGroup:SetFullHeight(true)
	itemGroup:SetLayout("List")
	container:AddChild(itemGroup)

	local pic = AceGUI:Create("Icon")
	if (MLsTexture ~= nil) then
		pic:SetImage(MLsTexture)
	else
		pic:SetImage(sTexture)
	end
	
	pic:SetWidth(165)
	pic:SetImageSize(40, 40)
	pic:SetCallback("OnEnter", function(pic) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(MyAddon.db.profile.droppedItemLink) if isOpen == true then  wishText:SetText(MyAddon.db.profile.droppedItemLink) end end)
	pic:SetCallback("OnLeave", function(pic) GameTooltip:Hide() end)
	itemGroup:AddChild(pic)

	local linebreak = AceGUI:Create("Label")
	linebreak:SetText(" ")
	itemGroup:AddChild(linebreak)
	
	local wishLabel = AceGUI:Create("Label")
	wishLabel:SetFullWidth(true)
	wishLabel:SetColor(1,0.8,0)
	itemGroup:AddChild(wishLabel)

	if (MyAddon.db.profile.epgpEnable or MLEPGPCost ~= nil) then
		local epgp = AceGUI:Create("Label")
			 
		if (MLEPGPCost ~= nil) then
			epgp:SetText("             "..LootSystem.." Cost: "..MLEPGPCost)
		elseif (MyAddon.db.profile.epgpEnable)  then
			LootSystem = MyAddon.db.profile.system
			epgp:SetText("             "..LootSystem.." Cost: "..iEPGPCost)
		else
			epgp:SetText(" ")
		end
		itemGroup:AddChild(epgp)
	end

	local linebreak = AceGUI:Create("Label")
	linebreak:SetText(" ")
	itemGroup:AddChild(linebreak)
	
	if (MLEPGPCost == nil)	then
		WorkoutPrimary()
	end
	
	local group = AceGUI:Create("InlineGroup")	
	group:SetTitle("Priorities")
	group:SetFullWidth(itemGroup)
	group:SetHeight(45)
	
	group:SetLayout("Fill")
	itemGroup:AddChild(group)

	scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow")
	group:AddChild(scroll)

	if (MLEPGPCost ~= nil)	then
		tablePrio = MLTablePrio
	end

	if (tablelength(classesTable) > 0 ) then
		if( sSubType == "Junk" ) then
			tablePrio = {}
			for i, value in ipairs(classesTable) do
				table.insert(tablePrio, {class = value.class, spec = "", prio = 14})
			end
		end
		table.wipe(classesTable)
	end

	RemoveUnderPrio()

	if (isRaidLooter) then
		local table = libS:Serialize(tablePrio)
		local data = MyAddon.db.profile.system.."/"..iEPGPCost.."/"..sName.."/"..sLink.."/"..iRarity.."/"..dropppediLevel.."/"..sType.."/"..sSubType.."/"..sEquip.."/"..sTexture.."/"..table
		local serial = libS:Serialize(data)
		local compress = libC:Compress(serial)
		local sendMessage = libCE:Encode(compress)
		MyAddon:SendCommMessage("LootingGuideNI", sendMessage, "RAID")
		isRaidLooter = false
	end

	local setColorR = 0
	local setColorG = 0
	local setColorB = 0

	sort(tablePrio, function(a,b) return a.prio > b.prio end)
	local count = 0
		
	for _, v in ipairs(tablePrio) do
		if (v.prio > 4) then
			count = count + 1
			local itemPrio = AceGUI:Create("Label")
			if (v.prio > 13) then
				setColorR = 1.0
			elseif (v.prio == 13) then
				setColorR = 1.0
				setColorG = 0.2
			elseif (v.prio == 12) then
				setColorR = 1.0
				setColorG = 0.4
			elseif (v.prio == 11) then
				setColorR = 1.0
				setColorG = 0.6
			elseif (v.prio == 10) then
				setColorR = 1.0
				setColorG = 0.8
			elseif (v.prio == 9) then
				setColorR = 1.0
				setColorG = 1.0
			elseif (v.prio == 8) then
				setColorR = 0.2
				setColorG = 1.0
			elseif (v.prio == 7) then
				setColorG = 1.0					
				setColorB = 0.2
			elseif (v.prio == 6) then
				setColorG = 1.0
				setColorB = 0.4
			end

			if( setColorR == 0 and setColorG == 0 and setColorB == 0 ) then
				setColorR = 1
				setColorG = 1
				setColorB = 1
			end
			itemPrio:SetColor(setColorR,setColorG,setColorB)
			itemPrio:SetText(v.prio.." - "..v.spec.." "..v.class)
			scroll:AddChild(itemPrio)
		end
	end
	if (count == 0) then
		local itemPrio = AceGUI:Create("Label")
		if( setColorR == 0 and setColorG == 0 and setColorB == 0 ) then
			setColorR = 1
			setColorG = 1
			setColorB = 1
		end
		itemPrio:SetColor(setColorR,setColorG,setColorB)
		itemPrio:SetText("         This item is useless")
		scroll:AddChild(itemPrio)
	end
					
	table.wipe(stats)
	table.wipe(statsTable)
	 
	local compareBtn = AceGUI:Create("Button")
	compareBtn:SetText("Compare Item")
	compareBtn:SetCallback("OnClick", compareItem)
	compareBtn:SetFullWidth(itemGroup)
	itemGroup:AddChild(compareBtn)

	_, _, dropID = string.find(MyAddon.db.profile.droppedItemLink, "item:(%d+):")

	for _, v in ipairs(MyAddon.db.profile.wishlist.items) do
		local _, _, ID = string.find(v.name, "item:(%d+):")
		if ( ID == dropID ) then
			wishLabel:SetText("     On Wish List for: " ..v.use)
			return
		end
	end		
end

function compareItem()
	if (comparing == false) then
		comparing = true

		PriorityTable()

		local i = tablelength(droppedItems)
		i = i - 2
		local height = 375 + (10 * i)

		frame:SetHeight(height)

		local slotId, texture, checkRelic = GetInventorySlotInfo(typeOfItem)

		local equipItem = GetInventoryItemLink("player", slotId)
		sName, sLink, _, iLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(equipItem)
		stats = GetItemStats(sLink, statsTable)
		
		compareGroup = AceGUI:Create("InlineGroup")
		compareGroup:SetTitle("Currently Equipped")
		compareGroup:SetWidth(190)
		compareGroup:SetLayout("List")
		tab:AddChild(compareGroup)
		
		local link = sLink

		local pic = AceGUI:Create("Icon")
		pic:SetImage(sTexture)
		pic:SetWidth(155)
		pic:SetImageSize(40, 40)
		pic:SetCallback("OnEnter", function(pic) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(link) end)
		pic:SetCallback("OnLeave", function(pic) GameTooltip:Hide() end)
		compareGroup:AddChild(pic)

		local label = AceGUI:Create("Label")
		label:SetText(sName)
		label:SetFullWidth(compareGroup)
		label:SetFontObject(GameFontNormalSmall)
		compareGroup:AddChild(label)
		
		WorkoutPrimary()

		EquipPrio()

		local linebreak = AceGUI:Create("Label")
		linebreak:SetText(" ")
		compareGroup:AddChild(linebreak)

		local group = AceGUI:Create("InlineGroup")
		group:SetTitle("Priorities")
		group:SetFullWidth(compareGroup)
		group:SetLayout("Fill")
		group:SetHeight(70)
		compareGroup:AddChild(group)

		scroll = AceGUI:Create("ScrollFrame")
		scroll:SetLayout("Flow")
		group:AddChild(scroll)

		local setColorR = 0
		local setColorG = 0
		local setColorB = 0

		sort(tablePrio, function(a,b) return a.prio > b.prio end)
		for _, v in ipairs(tablePrio) do
			if (v.prio > 4) then
				local itemPrio = AceGUI:Create("Label")
				if (v.prio > 13) then
					setColorR = 1.0
				elseif (v.prio == 13) then
					setColorR = 1.0
					setColorG = 0.2
				elseif (v.prio == 12) then
					setColorR = 1.0
					setColorG = 0.4
				elseif (v.prio == 11) then
					setColorR = 1.0
					setColorG = 0.6
				elseif (v.prio == 10) then
					setColorR = 1.0
					setColorG = 0.8
				elseif (v.prio == 9) then
					setColorR = 1.0
					setColorG = 1.0
				elseif (v.prio == 8) then
					setColorR = 0.2
					setColorG = 1.0
				elseif (v.prio == 7) then
					setColorG = 1.0					
					setColorB = 0.2
				elseif (v.prio == 6) then
					setColorG = 1.0
					setColorB = 0.4
				end

				if( setColorR == 0 and setColorG == 0 and setColorB == 0 ) then
					setColorR = 1
					setColorG = 1
					setColorB = 1
				end
				itemPrio:SetColor(setColorR, setColorG, setColorB)
				itemPrio:SetText(v.prio.." - "..v.spec.." "..v.class)
				scroll:AddChild(itemPrio)
			end
		end

		table.wipe(tablePrio)
		table.wipe(stats)
		 
		if (typeOfItem1 ~= nil) then
			frame:SetWidth(634)
			compareItem1()
		else
			frame:SetWidth(444)
		end
	else
		comparing = false			
		ItemSelect(droppedIDs[1])
		MyAddon.db.profile.isOpen = false
		AceGUI:Release(frame)
		ActivatePrint()
		tab:SelectTab(0)
	end
end

function compareItem1()	
	PriorityTable()

	local i = tablelength(droppedItems)
	i = i - 2
	local height = 375 + (8 * i)

	frame:SetHeight(height)
	
	local slotId, texture, checkRelic = GetInventorySlotInfo(typeOfItem1)

	local equipIem = GetInventoryItemLink("player", slotId)
	sName, sLink, _, iLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(equipIem)
	stats = GetItemStats(sLink, statsTable)
		
	compareGroup = AceGUI:Create("InlineGroup")
	compareGroup:SetTitle("Currently Equipped")
	compareGroup:SetWidth(190)
	compareGroup:SetLayout("List")
	tab:AddChild(compareGroup)
	
	local link = sLink

	local pic = AceGUI:Create("Icon")
	pic:SetImage(sTexture)
	pic:SetWidth(155)
	pic:SetImageSize(40, 40)
	pic:SetCallback("OnEnter", function(pic) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(link) end)
	pic:SetCallback("OnLeave", function(pic) GameTooltip:Hide() end)
	compareGroup:AddChild(pic)

	local label = AceGUI:Create("Label")
	label:SetText(sName)
	label:SetFullWidth(compareGroup)
	label:SetFontObject(GameFontNormalSmall)
	compareGroup:AddChild(label)
		
	WorkoutPrimary()
	
	EquipPrio()

	local linebreak = AceGUI:Create("Label")
	linebreak:SetText(" ")
	compareGroup:AddChild(linebreak)

	local group = AceGUI:Create("InlineGroup")
	group:SetTitle("Priorities")
	group:SetFullWidth(compareGroup)
	group:SetLayout("Fill")
	group:SetHeight(70)
	compareGroup:AddChild(group)

	scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow")
	group:AddChild(scroll)

	local setColorR = 0
	local setColorG = 0
	local setColorB = 0

	sort(tablePrio, function(a,b) return a.prio > b.prio end)
	for _, v in ipairs(tablePrio) do
		if (v.prio > 4) then
			local itemPrio = AceGUI:Create("Label")
			if (v.prio > 13) then
				setColorR = 1.0
			elseif (v.prio == 13) then
				setColorR = 1.0
				setColorG = 0.2
			elseif (v.prio == 12) then
				setColorR = 1.0
				setColorG = 0.4
			elseif (v.prio == 11) then
				setColorR = 1.0
				setColorG = 0.6
			elseif (v.prio == 10) then
				setColorR = 1.0
				setColorG = 0.8
			elseif (v.prio == 9) then
				setColorR = 1.0
				setColorG = 1.0
			elseif (v.prio == 8) then
				setColorR = 0.2
				setColorG = 1.0
			elseif (v.prio == 7) then
				setColorG = 1.0					
				setColorB = 0.2
			elseif (v.prio == 6) then
				setColorG = 1.0
				setColorB = 0.4
			end
			
			if( setColorR == 0 and setColorG == 0 and setColorB == 0 ) then
				setColorR = 1
				setColorG = 1
				setColorB = 1
			end
			itemPrio:SetColor(setColorR,setColorG,setColorB)
			itemPrio:SetText(v.prio.." - "..v.spec.." "..v.class)
			scroll:AddChild(itemPrio)
		end
	end

	table.wipe(tablePrio)
	table.wipe(stats)
	 
end

function WorkoutPrimary()
	primaryStat = nil
	for stat, value in pairs(stats) do
		if (_G[stat] == "Agility") then
			primaryStat = "Agility"				
		elseif (_G[stat] == "Intellect") then
			primaryStat = "Intellect"
		elseif (_G[stat] == "Strength") then
			primaryStat = "Strength"
		end
	end

	if (primaryStat == nil) then
		for stat, value in pairs(stats) do
			if (_G[stat] == "Stamina") then
				primaryStat = "Stamina"
			end
		end
	end
		
	WorkoutStats()
end

function EquipPrio()
	local class = UnitClass("player")
	for i, v in pairs(tablePrio) do
		if (v.class ~= class) then
			v.prio = 0
		else
			if (iLevel > dropppediLevel) then
				v.prio = v.prio + 1
			elseif (iLevel < dropppediLevel) then
				v.prio = v.prio - 1
			end
		end
	end
end

function WorkoutStats()		
	for stat, value in pairs(stats) do			
		if (_G[stat] == "Agility") then
			MainStat("Agility")				
		elseif (_G[stat] == "Intellect") then
			MainStat("Intellect")
		elseif (_G[stat] == "Strength") then
			MainStat("Strength")
		end

		if (sType ~= "Weapon") then
			if (_G[stat] == "Critical Strike" or _G[stat] == "Critical Strike Rating") then
				SecondaryStat("Crit")
			end

			if (_G[stat] == "Haste" or _G[stat] == "Haste Rating") then
				SecondaryStat("Haste")
			end

			if (_G[stat] == "Mastery" or _G[stat] == "Mastery Rating") then
				SecondaryStat("Mastery")
			end

			if (_G[stat] == "Hit" or _G[stat] == "Hit Rating") then
				SecondaryStat("Hit")
			end

			if (_G[stat] == "Expertise" or _G[stat] == "Expertise Rating") then
				SecondaryStat("Expertise")
			end

			if (_G[stat] == "Parry" or _G[stat] == "Parry Rating") then
				SecondaryStat("Parry")
			end

			if (_G[stat] == "Dodge" or _G[stat] == "Dodge Rating") then
				SecondaryStat("Dodge")
			end
		end

		if (_G[stat] == "Spirit") then
			SecondaryStat("Spirit")
		end
	end

	if (sType == "Armor") then
		Armour()
	elseif (sType == "Weapon") then
		Weapon()
	elseif (sType == "Miscellaneous") then
		Misc()
	end
end

function Armour()
	if ( (sEquip == "INVTYPE_CLOAK") or (sSubType == "Miscellaneous") or (sEquip == "INVTYPE_TRINKET")) then
		if( primaryStat ~= nil) then
			MainStat(primaryStat)
		else
			for stat, value in pairs(stats) do
				if (_G[stat] == "Stamina") then
					MainStat("Stamina")
				end
			end
		end

		if (sEquip == "INVTYPE_TRINKET") then
			ToolTipScanner(false)
		end
	elseif (sSubType == "Plate") then
		if (primaryStat == "Intellect") then
			for _, value in ipairs(tablePrio) do
				if ( value.class == "Paladin" and value.spec == "Holy") then
					value.prio = value.prio + 5
				else
					value.prio = -50
				end  
			end
		else
			for _, value in ipairs(tablePrio) do
				if ( value.class == "Death Knight" or value.spec == "Retribution" or (value.class == "Paladin" and value.spec == "Protection") or value.class == "Warrior") then
					value.prio = value.prio + 5
				else
					value.prio = -50
				end  
			end
		end
	elseif (sSubType == "Mail") then
		if (primaryStat == "Intellect") then
			for _, value in ipairs(tablePrio) do
				if ( value.spec == "Elemental" or (value.class == "Shaman" and value.spec == "Restoration")) then
					value.prio = value.prio + 5
				else
					value.prio = -50
				end  
			end
		else
			for _, value in ipairs(tablePrio) do
				if ( value.class == "Hunter" or value.spec == "Enhancement") then
					value.prio = value.prio + 5
				else
					value.prio = -50
				end  
			end	
		end
	elseif (sSubType == "Leather") then
		if (primaryStat == "Intellect") then
			for _, value in ipairs(tablePrio) do
				if ( (value.class == "Druid" and value.spec == "Restoration") or value.spec == "Balance" or value.spec == "Mistweaver") then
					value.prio = value.prio + 5
				else
					value.prio = -50
				end  
			end
		else
			for _, value in ipairs(tablePrio) do
				if (value.spec == "Feral" or value.spec == "Guardian" or value.class == "Rogue" or value.spec == "Windwalker" or value.spec == "Brewmaster") then
					value.prio = value.prio + 5
				else
					value.prio = -50
				end  
			end
		end
	elseif (sSubType == "Cloth") then
		for _, value in ipairs(tablePrio) do
			if ( value.class == "Mage" or value.class == "Priest" or value.class == "Warlock") then
				value.prio = value.prio + 5
			else
				value.prio = -50
			end  
		end
	elseif (sSubType == "Shields") then
		for _, value in ipairs(tablePrio) do
			if (value.spec == "Protection" or value.spec == "Elemental" or (value.class == "Shaman" and value.spec == "Restoration") or (value.class == "Paladin" and value.spec == "Holy")) then
				value.prio = value.prio + 5
			else
				value.prio = -50
			end  
		end		
	end
end

function Weapon()
	ToolTipScanner(false)
	if (sSubType == "Bows") then
		for _, value in ipairs(tablePrio) do
			if ( value.class == "Hunter") then
				value.prio = value.prio + 5
			elseif (value.class == "Rogue" or value.class == "Warrior") then
				value.prio = value.prio + 2
			else
				value.prio = -50
			end  
		end
	elseif (sSubType == "Crossbows") then
		for _, value in ipairs(tablePrio) do
			if (value.class == "Hunter") then
				value.prio = value.prio + 5
			elseif (value.class == "Rogue" or value.class == "Warrior") then
				value.prio = value.prio + 2
			else
				value.prio = -50
			end  
		end
	elseif (sSubType == "Daggers") then
		for _, value in ipairs(tablePrio) do
			if (value.class == "Druid" or value.class == "Mage" or value.class == "Priest" or value.class == "Rogue"  or value.class == "Shaman" or value.class == "Warlock") then
				value.prio = value.prio + 5
			elseif (value.class == "Hunter" or value.class == "Warrior") then
				value.prio = value.prio + 2
			else
				value.prio = -50
			end  
		end
	elseif (sSubType == "Guns") then
		for _, value in ipairs(tablePrio) do
			if ( value.class == "Hunter") then
				value.prio = value.prio + 5
			elseif (value.class == "Rogue" or value.class == "Warrior") then
				value.prio = value.prio + 2
			else
				value.prio = -50
			end  
		end
	elseif (sSubType == "Fist Weapons") then
		for _, value in ipairs(tablePrio) do
			if ( value.class == "Druid" or value.class == "Monk" or value.class == "Rogue"  or value.class == "Shaman" or value.class == "Warrior") then
				value.prio = value.prio + 5
			elseif (value.class == "Hunter") then
				value.prio = value.prio + 2
			else
				value.prio = -50
			end  
		end
	elseif (sSubType == "One-Handed Axes") then
		for _, value in ipairs(tablePrio) do
			if ( value.class == "Death Knight" or value.class == "Monk" or value.class == "Paladin" or value.class == "Rogue"  or value.class == "Shaman" or value.class == "Warrior") then
				value.prio = value.prio + 5
			elseif (value.class == "Hunter") then
				value.prio = value.prio + 2
			else
				value.prio = -50
			end  
		end						
	elseif (sSubType == "One-Handed Maces") then
		for _, value in ipairs(tablePrio) do
			if ( value.class == "Death Knight" or value.class == "Druid" or value.class == "Monk" or value.class == "Paladin" or value.class == "Priest" or value.class == "Rogue"  or value.class == "Shaman" or value.class == "Warrior") then
				value.prio = value.prio + 5
			else
				value.prio = -50
			end  
		end
	elseif (sSubType == "One-Handed Swords") then
		for _, value in ipairs(tablePrio) do
			if ( value.class == "Death Knight" or value.class == "Mage" or value.class == "Monk" or value.class == "Paladin" or value.class == "Rogue"  or value.class == "Warlock" or value.class == "Warrior") then
				value.prio = value.prio + 5
			elseif (value.class == "Hunter") then
				value.prio = value.prio + 2
			else
				value.prio = -50
			end  
		end	
	elseif (sSubType == "Polearms") then
		for _, value in ipairs(tablePrio) do
			if ( value.class == "Death Knight" or value.class == "Druid" or value.class == "Hunter" or value.class == "Monk" or value.class == "Paladin" or value.class == "Shaman" or value.class == "Warrior") then
				value.prio = value.prio + 5
			else
				value.prio = -50
			end  
		end			
	elseif (sSubType == "Staves") then
		for _, value in ipairs(tablePrio) do
			if (value.class == "Druid" or value.class == "Hunter" or value.class == "Mage" or value.class == "Monk" or value.class == "Priest" or value.class == "Shaman" or value.class == "Warlock" or value.class == "Warrior") then
				value.prio = value.prio + 5
			else
				value.prio = -50
			end  
		end  
	elseif (sSubType == "Two-Handed Axes") then
		for _, value in ipairs(tablePrio) do
			if (value.class == "Death Knight" or value.class == "Hunter" or value.class == "Paladin" or value.class == "Warrior") then
				value.prio = value.prio + 5
			else
				value.prio = -50
			end  
		end
	elseif (sSubType == "Two-Handed Maces") then
		for _, value in ipairs(tablePrio) do
			if (value.class == "Death Knight" or value.class == "Paladin" or value.class == "Warrior") then
				value.prio = value.prio + 5
			else
				value.prio = -50
			end  
		end	
	elseif (sSubType == "Two-Handed Swords") then
		for _, value in ipairs(tablePrio) do
			if (value.class == "Death Knight" or value.class == "Hunter" or value.class == "Paladin" or value.class == "Warrior") then
				value.prio = value.prio + 5
			else
				value.prio = -50
			end  
		end
	elseif (sSubType == "Wands") then
		for _, value in ipairs(tablePrio) do
			if (value.class == "Mage" or value.class == "Priest" or value.class == "Warlock") then
				value.prio = value.prio + 5
			else
				value.prio = -50
			end  
		end
	end
end

function Misc()
	for _, value in ipairs(tablePrio) do
		value.prio = 14
	end
end

function MainStat(Mstat)
	for _, value in ipairs(tablePrio) do
		if (value.mainstat == Mstat) then
			value.prio = value.prio + 5
		elseif (value.mainstat == "Stamina" and ((value.class ~= "Druid" or value.class ~= "Monk") and Mstat == "Strength")) then 
			value.prio = value.prio + 2	
		elseif (value.mainstat == "Stamina" and ((value.class == "Druid" or value.class == "Monk") and Mstat == "Agility")) then
			value.prio = value.prio + 5
		elseif (Mstat == "Stamina" and value.mainstat ~= Mstat) then
			--value.prio = 0
		else
			value.prio = -50
		end
	end
end

function SecondaryStat(Sstat)
	for _, value in ipairs(tablePrio) do
		if Sstat == "Crit" then
			value.prio = value.prio + value.critical
		elseif Sstat == "Haste" then
			value.prio = value.prio + value.haste
		elseif Sstat == "Mastery" then
			value.prio = value.prio + value.mastery
		elseif Sstat == "Hit" then
			if (value.spirit == 2) then
				value.prio = value.prio - 2
			else
				value.prio = value.prio + value.hit
			end
		elseif Sstat == "Expertise" then
			value.prio = value.prio + value.expertise
		elseif Sstat == "Spirit" then
			if (value.spirit ~= 0) then
				value.prio = value.prio + value.spirit
			else
				value.prio = value.prio - 2
			end
		elseif Sstat == "Dodge" then
			if (value.dodge ~= 0) then
				value.prio = value.prio + value.dodge
			else
				value.prio = value.prio - 5	
			end 
		elseif Sstat == "Parry" then
			if (value.parry ~= 0) then
				value.prio = value.prio + value.parry
			else
				value.prio = value.prio - 5	
			end
		end
	end
end

function ToolTipScanner(lockCheck)	
	CreateFrame( "GameTooltip", "GearingTooltip", nil, "GameTooltipTemplate" ); -- Tooltip name cannot be nil
	GearingTooltip:SetOwner( WorldFrame, "ANCHOR_NONE" );
	GearingTooltip:ClearLines()
	GearingTooltip:SetHyperlink(sLink)
	
	if (lockCheck == true) then	
		EnumerateTooltipLines_helperToken(GearingTooltip:GetRegions())
	else
		EnumerateTooltipLines_helper(GearingTooltip:GetRegions())
	end	
end

function EnumerateTooltipLines_helperToken(...)
	for i = 1, select("#", ...) do
        local region = select(i, ...)
        if region and region:GetObjectType() == "FontString" then
            local text = region:GetText() -- string or nil
			if (text ~= nil) then
				local startPos, endPos, firstWord, restOfString = string.find( text, "(%w+)[%s%p]*(.*)")
				
				if (firstWord == "Classes") then
					classesTable = {}
					
					local foundWord = string.find(restOfString, "Death Knight")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Death Knight"})
					end

					local foundWord = string.find(restOfString, "Druid")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Druid"})
					end

					local foundWord = string.find(restOfString, "Hunter")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Hunter"})
					end

					local foundWord = string.find(restOfString, "Mage")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Mage"})
					end

					local foundWord = string.find(restOfString, "Monk")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Monk"})
					end

					local foundWord = string.find(restOfString, "Paladin")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Paladin"})
					end

					local foundWord = string.find(restOfString, "Priest")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Priest"})
					end

					local foundWord = string.find(restOfString, "Rogue")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Rogue"})
					end

					local foundWord = string.find(restOfString, "Shaman")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Shaman"})
					end

					local foundWord = string.find(restOfString, "Warlock")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Warlock"})
					end

					local foundWord = string.find(restOfString, "Warrior")
					if (foundWord ~= nil) then
						table.insert(classesTable, {class = "Warrior"})
					end
				end
			end
		end
	end
end

function EnumerateTooltipLines_helper(...)
    for i = 1, select("#", ...) do
        local region = select(i, ...)
        if region and region:GetObjectType() == "FontString" then
            local text = region:GetText() -- string or nil
			if (text ~= nil) then
				local startPos, endPos, firstWord, restOfString = string.find( text, "(%w+)[%s%p]*(.*)")
				
				local count = 0
				if ((firstWord == "Equip") or (firstWord == "Use")) then
					if (sType ~= "Weapon") then
						local foundWord = string.find(restOfString, "spell power")
						if (foundWord ~= nil) then
							MainStat("Intellect")
						end
					end
					
					foundWord = string.find(restOfString, "spells")
					if (foundWord ~= nil) then
						foundWord = string.find(restOfString, "harmful")
						if (foundWord ~= nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.mainstat == "Intellect" and value.spirit ~= 2) then
									if (value.prio > 9) then
										value.prio = value.prio + 2
									else
										value.prio = value.prio + 5
									end	
								else
									value.prio = value.prio - 5
								end
							end
						end

						foundWord = string.find(restOfString, "healing and damaging")
						if (foundWord ~= nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.mainstat == "Intellect") then
									if (value.prio > 5) then
										value.prio = value.prio + 2
									else
										value.prio = value.prio + 5
									end	
								else
									value.prio = value.prio - 15
								end
							end
						else
							foundWord = string.find(restOfString, "damaging")
							if (foundWord ~= nil) then
								for _, value in ipairs(tablePrio) do						
									if (value.mainstat == "Intellect" and value.spirit ~= 2) then
										if (value.prio > 9) then
											value.prio = value.prio + 2
										else
											value.prio = value.prio + 5
										end	
									else
										value.prio = value.prio - 5
									end
								end
							end

							foundWord = string.find(restOfString, "healing")
							if (foundWord ~= nil) then
								for _, value in ipairs(tablePrio) do						
									if (value.mainstat == "Intellect" and value.spirit == 2) then
										if (value.prio > 9) then
											value.prio = value.prio + 2
										else
											value.prio = value.prio + 5
										end	
									else
										value.prio = value.prio - 5
									end
								end
							end

							foundWord = string.find(restOfString, "dealing damage")
							if (foundWord ~= nil) then
								for _, value in ipairs(tablePrio) do						
									if (value.mainstat == "Intellect" and value.spirit ~= 2) then
										if (value.prio > 9) then
											value.prio = value.prio + 2
										else
											value.prio = value.prio + 5
										end	
									else
										value.prio = value.prio - 5
									end
								end
							end
						end
					else
						findStat = string.find(restOfString, "heal")
						if (findStat ~= nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.spirit == 2) then
									if (value.prio > 9) then
										value.prio = value.prio + 2
									else
										value.prio = value.prio + 5
									end
								elseif (value.dodge ~= 0) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio - 5	
								end
							end
						end					
					end

					foundWord = string.find(restOfString, "harmful spellcasts")
					if (foundWord ~= nil) then
						for _, value in ipairs(tablePrio) do
							if (value.mainstat == "Intellect" and value.spirit ~= 2) then
								value.prio = value.prio + 5
							else
								value.prio = value.prio - 5
							end
						end
					end
					
					foundWord = string.find(restOfString, "melee and ranged attacks")
					if (foundWord ~= nil) then
						for _, value in ipairs(tablePrio) do					
							if (value.spirit == 2) then
								value.prio = value.prio - 5
							elseif (value.mainstat ~= "Intellect") then							
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end						
							else
								value.prio = value.prio - 5
							end
						end
					else
						foundWord = string.find(restOfString, "attacks")
						if (foundWord ~= nil) then
							for _, value in ipairs(tablePrio) do					
								if (value.spirit == 2) then
									value.prio = value.prio - 5
								else
									if (value.prio > 9) then
										value.prio = value.prio + 2
									else
										value.prio = value.prio + 5
									end						
								end
							end
						end
					end

					foundWord = string.find(restOfString, "maximum health")
					if (foundWord ~= nil) then
						for _, value in ipairs(tablePrio) do					
							if (value.dodge ~= 0) then
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end	
							else
								value.prio = value.prio - 5						
							end
						end
					end

					foundWord = string.find(restOfString, "physical absorb shield")
					if (foundWord ~= nil) then
						for _, value in ipairs(tablePrio) do					
							if (value.dodge ~= 0) then
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end	
							else
								value.prio = value.prio - 5						
							end
						end
					end

					if (sType ~= "Weapon") then
						foundWord = string.find(restOfString, "parry")
						if (foundWord ~= nil) then
							SecondaryStat("Parry")
						end

						foundWord = string.find(restOfString, "dodge")
						if (foundWord ~= nil) then
							for _, value in ipairs(tablePrio) do					
								if (value.dodge ~= 0) then
									if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end	
								else
									value.prio = value.prio - 5						
								end
							end
						end
					end

					foundWord = string.find(restOfString, "mana")
					if (foundWord ~= nil) then
						for _, value in ipairs(tablePrio) do						
							if (value.spirit == 2) then
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end	
							end
						end
						SecondaryStat("Spirit")
					end

					local findStat = string.find(restOfString, "haste")
					if (findStat ~= nil) then
						if (sType ~= "Weapon" and primaryStat == nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.haste > 0) then
									value.prio = value.prio + 2
								end
							end
						end
						SecondaryStat("Haste")
					end

					findStat = string.find(restOfString, "critical")
					if (findStat ~= nil) then
						if (sType ~= "Weapon" and primaryStat == nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.critical > 0) then
									value.prio = value.prio + 2
								end
							end
						end
						SecondaryStat("Crit")
					end

					findStat = string.find(restOfString, "mastery")
					if (findStat ~= nil) then
						if (sType ~= "Weapon" and primaryStat == nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.mastery > 0) then
									value.prio = value.prio + 2
								end
							end
						end
						SecondaryStat("Mastery")
					end

					findStat = string.find(restOfString, "spirit")
					if (findStat ~= nil) then
						if (sType ~= "Weapon" and primaryStat == nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.spirit == 2) then
									value.prio = value.prio + 2
								end
							end
						end
						SecondaryStat("Spirit")
					end

					findStat = string.find(restOfString, "Spirit")
					if (findStat ~= nil) then
						if (sType ~= "Weapon" and primaryStat == nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.spirit == 2) then
									value.prio = value.prio + 2
								end
							end
						end
						SecondaryStat("Spirit")
					end

					findStat = string.find(restOfString, "dodge")
					if (findStat ~= nil) then
						if (sType ~= "Weapon" and primaryStat == nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.dodge == 2) then
									value.prio = value.prio + 2
								end
							end
						end
						SecondaryStat("Dodge")
					end
					
					findStat = string.find(restOfString, "parry")
					if (findStat ~= nil) then
						if (sType ~= "Weapon" and primaryStat == nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.parry == 2) then
									value.prio = value.prio + 2
								end
							end
						end
						SecondaryStat("Parry")
					end

					findStat = string.find(restOfString, "expertise")
					if (findStat ~= nil) then
						if (sType ~= "Weapon" and primaryStat == nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.expertise > 0) then
									value.prio = value.prio + 2
								end
							end
						end
						SecondaryStat("Expertise")
					end

					findStat = string.find(restOfString, "hit")
					if (findStat ~= nil) then
						if (sType ~= "Weapon" and primaryStat == nil) then
							for _, value in ipairs(tablePrio) do						
								if (value.spirit ~= 2) then
									value.prio = value.prio + 2
								end
							end
						end
						SecondaryStat("Hit")
					end

					if (sType ~= "Weapon") then
						findStat = string.find(restOfString, "Intellect")
						if (findStat ~= nil) then
							MainStat("Intellect")
							for _, value in ipairs(tablePrio) do
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end
							end
						end

						findStat = string.find(restOfString, "Strength")
						if (findStat ~= nil) then
							MainStat("Strength")
							for _, value in ipairs(tablePrio) do
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end
							end
						end

						findStat = string.find(restOfString, "Agility")
						if (findStat ~= nil) then
							MainStat("Agility")
							for _, value in ipairs(tablePrio) do
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end
							end
						end

						findStat = string.find(restOfString, "Stamina")
						if (findStat ~= nil) then
							MainStat("Stamina")
							for _, value in ipairs(tablePrio) do
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end
							end
						end
					end
					
					findStat = string.find(restOfString, "deal damage")
					if (findStat ~= nil) then
						for _, value in ipairs(tablePrio) do
							if (value.spirit == 2) then
								value.prio = value.prio - 5
							else
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end
							end
						end
					end

					findStat = string.find(restOfString, "damage dealing")
					if (findStat ~= nil) then
						for _, value in ipairs(tablePrio) do
							if (value.spirit == 2) then
								value.prio = value.prio - 5
							else
								if (value.prio > 9) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio + 5
								end
							end
						end
					end
				end
			end
        end
    end
end

function WorkOutEPGP()
	if (MyAddon.db.profile.inGuild == true) then
		if (sType == "Miscellaneous") then
			local name, left = strsplit(" ", sName, 2)
			if (name == "Gauntlets") then
				typeOfItem = "HandsSlot"
				iEPGPCost = MyAddon.db.profile.custom.GlovesGP
			elseif (name == "Pauldrons" or name == "Mantle" or name == "Shoulders") then
				typeOfItem = "ShoulderSlot"
				iEPGPCost = MyAddon.db.profile.custom.ShouldersGP
			elseif (name == "Chestguard" or name == "Chest") then
				typeOfItem = "ChestSlot"
				iEPGPCost = MyAddon.db.profile.custom.ChestGP	
			elseif (name == "Leggings") then
				typeOfItem = "LegsSlot"
				iEPGPCost = MyAddon.db.profile.custom.LegsGP	
			elseif (name == "Crown" or name == "Helm") then
				typeOfItem = "HeadSlot"
				iEPGPCost = MyAddon.db.profile.custom.HelmGP
			else
				iEPGPCost = 0		
			end
		elseif (sEquip == "INVTYPE_HEAD") then
			typeOfItem = "HeadSlot"
			iEPGPCost = MyAddon.db.profile.custom.HelmGP
		elseif (sEquip == "INVTYPE_LEGS") then
			typeOfItem = "LegsSlot"
			iEPGPCost = MyAddon.db.profile.custom.LegsGP	
		elseif (sEquip == "INVTYPE_CHEST" or sEquip == "INVTYPE_ROBE") then
			typeOfItem = "ChestSlot"
			iEPGPCost = MyAddon.db.profile.custom.ChestGP
		elseif (sEquip == "INVTYPE_NECK") then
			typeOfItem = "NeckSlot"
			iEPGPCost = MyAddon.db.profile.custom.NeckGP
		elseif (sEquip == "INVTYPE_CLOAK") then
			typeOfItem = "BackSlot"
			iEPGPCost = MyAddon.db.profile.custom.CloakGP
		elseif (sEquip == "INVTYPE_WRIST") then
			typeOfItem = "WristSlot"
			iEPGPCost = MyAddon.db.profile.custom.WristGP
		elseif (sEquip == "INVTYPE_FINGER") then
			typeOfItem = "Finger0Slot"
			typeOfItem1 = "Finger1Slot"
			iEPGPCost = MyAddon.db.profile.custom.RingGP
		elseif (sEquip == "INVTYPE_SHOULDER") then
			typeOfItem = "ShoulderSlot"
			iEPGPCost = MyAddon.db.profile.custom.ShouldersGP
		elseif (sEquip == "INVTYPE_HAND") then
			typeOfItem = "HandsSlot"
			iEPGPCost = MyAddon.db.profile.custom.GlovesGP
		elseif (sEquip == "INVTYPE_WAIST") then
			typeOfItem = "WaistSlot"
			iEPGPCost = MyAddon.db.profile.custom.WaistGP
		elseif (sEquip == "INVTYPE_FEET") then
			typeOfItem = "FeetSlot"
			iEPGPCost = MyAddon.db.profile.custom.BootsGP
		elseif (sEquip == "INVTYPE_TRINKET") then
			typeOfItem = "Trinket0Slot"
			typeOfItem1 = "Trinket1Slot"
			iEPGPCost = MyAddon.db.profile.custom.TrinketGP
		elseif (sEquip == "INVTYPE_SHIELD" or sEquip == "INVTYPE_WEAPONOFFHAND" or sEquip == "INVTYPE_HOLDABLE") then
			typeOfItem = "SecondaryHandSlot"
			iEPGPCost = MyAddon.db.profile.custom.OffhandGP
		elseif (sEquip == "INVTYPE_2HWEAPON" or sEquip == "INVTYPE_RANGED") then
			typeOfItem = "MainHandSlot"
			iEPGPCost = MyAddon.db.profile.custom.WeaponGP
		elseif (sEquip == "INVTYPE_WEAPONMAINHAND" or sEquip == "INVTYPE_WEAPON" or sEquip == "INVTYPE_RANGEDRIGHT") then
			typeOfItem = "MainHandSlot"
			iEPGPCost = MyAddon.db.profile.custom.MainhandGP
		else
			iEPGPCost = 0
		end
	else
		local gpCost = 0
		if (iRarity == 4) then
			gpCost = (dropppediLevel - 1.3) / 1.3
		elseif (iRarity == 3) then
			gpCost = (dropppediLevel - 1.84) / 1.6
		elseif (iRarity == 2) then
			gpCost = (dropppediLevel - 4) / 2
		end
		gpCost = (gpCost * gpCost) * 0.04
		if (sType == "Miscellaneous") then
			local name, left = strsplit(" ", sName, 2)
			if (name == "Gauntlets") then
				typeOfItem = "HandsSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.GlovesGP)
			elseif (name == "Pauldrons" or name == "Mantle" or name == "Shoulders") then
				typeOfItem = "ShoulderSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.ShouldersGP)
			elseif (name == "Chestguard" or name == "Chest") then
				typeOfItem = "ChestSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.ChestGP)	
			elseif (name == "Leggings") then
				typeOfItem = "LegsSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.LegsGP)	
			elseif (name == "Crown" or name == "Helm") then
				typeOfItem = "HeadSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.HelmGP)		
			end
		elseif (sEquip == "INVTYPE_HEAD") then
			typeOfItem = "HeadSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.HelmGP)
		elseif (sEquip == "INVTYPE_LEGS") then
			typeOfItem = "LegsSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.LegsGP)	
		elseif (sEquip == "INVTYPE_CHEST" or sEquip == "INVTYPE_ROBE") then
			typeOfItem = "ChestSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.ChestGP)
		elseif (sEquip == "INVTYPE_NECK") then
			typeOfItem = "NeckSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.NeckGP)
		elseif (sEquip == "INVTYPE_CLOAK") then
			typeOfItem = "BackSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.CloakGP)
		elseif (sEquip == "INVTYPE_WRIST") then
			typeOfItem = "WristSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.WristGP)
		elseif (sEquip == "INVTYPE_FINGER") then
			typeOfItem = "Finger0Slot"
			typeOfItem1 = "Finger1Slot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.RingGP)
		elseif (sEquip == "INVTYPE_SHOULDER") then
			typeOfItem = "ShoulderSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.ShouldersGP)
		elseif (sEquip == "INVTYPE_HAND") then
			typeOfItem = "HandsSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.GlovesGP)
		elseif (sEquip == "INVTYPE_WAIST") then
			typeOfItem = "WaistSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.WaistGP)
		elseif (sEquip == "INVTYPE_FEET") then
			typeOfItem = "FeetSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.BootsGP)
		elseif (sEquip == "INVTYPE_TRINKET") then
			typeOfItem = "Trinket0Slot"
			typeOfItem1 = "Trinket1Slot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.TrinketGP)
		elseif (sEquip == "INVTYPE_SHIELD" or sEquip == "INVTYPE_WEAPONOFFHAND" or sEquip == "INVTYPE_HOLDABLE") then
			typeOfItem = "SecondaryHandSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.OffhandGP)
		elseif (sEquip == "INVTYPE_2HWEAPON" or sEquip == "INVTYPE_RANGED") then
			typeOfItem = "MainHandSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.WeaponGP)
		elseif (sEquip == "INVTYPE_WEAPONMAINHAND" or sEquip == "INVTYPE_WEAPON" or sEquip == "INVTYPE_RANGEDRIGHT") then
			typeOfItem = "MainHandSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.MainhandGP)
		else
			iEPGPCost = 0
		end
	end
end

function LoadFramePosition()
	MyAddon.db = LibStub("AceDB-3.0"):New("GearingGuideDB1", defaults)
	frame:ClearAllPoints()
	frame:SetPoint(MyAddon.db.profile.point, UIParent, MyAddon.db.profile.relPoint, MyAddon.db.profile.x, MyAddon.db.profile.y)
end

function SaveFramePosition()
	local point, _, relativePoint, xOffset, yOffset = frame:GetPoint()
	if (MyAddon.db.profile.x ~= xOffset) or (MyAddon.db.profile.y ~= yOffset) then
		MyAddon.db.profile.point = point
		MyAddon.db.profile.relPoint = relativePoint
		MyAddon.db.profile.x = xOffset
		MyAddon.db.profile.y = yOffset
	end
end

function tablelength(T) 
	local count = 0 
	for _ in pairs(T) do count = count + 1 end 
	return count 
end

function WishListFrame()
	isOpen = true				
	local wishFrame = AceGUI:Create("Frame")
	firstcheck = false 

	wishFrame:SetTitle("Wish List")
	wishFrame:SetCallback("OnClose", function(frame) isOpen = false AceGUI:Release(wishFrame) end)			
	wishFrame:SetLayout("Flow")
	wishFrame:SetWidth(400)
	wishFrame:SetHeight(500)
	wishFrame:EnableResize(Hide)
	
	wishText = AceGUI:Create("EditBox")
	wishText:SetLabel("Enter Item:")
	wishFrame:AddChild(wishText)

	local useList = {["choice1"] = "Main Spec", ["choice2"] = "Off Spec", ["choice3"] ="Transmog"}

	local wishDrop = AceGUI:Create("Dropdown")
	wishDrop:SetLabel("What would you like the item for:")
	wishDrop:SetList(useList)
	wishDrop:SetValue("choice1")
	wishFrame:AddChild(wishDrop)

	local wishGroup = AceGUI:Create("InlineGroup")
	wishGroup:SetTitle("Wish List Items")
	wishGroup:SetFullWidth(wishFrame)
	wishGroup:SetFullHeight(true)
	wishGroup:SetLayout("Fill")
	wishFrame:AddChild(wishGroup)
	
	wishText:SetCallback("OnEnterPressed", function(wishText)
	local name, link = GetItemInfo(wishText:GetText())
	if ( name ~= nil ) then
		if (IsEquippableItem(link) ~= nil) then 
			table.insert(MyAddon.db.profile.wishlist.items, {name = link, use = useList[wishDrop:GetValue()]})
			wishText:SetText("")
			wishFrame:SetStatusText("") 
			ItemList(wishFrame, wishGroup)
			droppedText = ""
		else
			wishFrame:SetStatusText("You can't use this item")
		end
	else
		wishFrame:SetStatusText("Item doesn't exist")
	end 
	end)

	if (tablelength(MyAddon.db.profile.wishlist.items) > 0) then
		ItemList(wishFrame, wishGroup)
	end
end

function ItemList(wishframe, container)	
	container:ReleaseChildren()

	local scrollList = AceGUI:Create("ScrollFrame")
	scrollList:SetLayout("Flow")
	container:AddChild(scrollList)

	for i, v in pairs(MyAddon.db.profile.wishlist.items) do
		local itemList = AceGUI:Create("InteractiveLabel")
		itemList:SetText(v.name)
		itemList:SetFullWidth(true)
		itemList:SetFontObject(GameFontNormal)
		itemList:SetCallback("OnClick", function(button) MyAddon:Print("Deleted this: "..v.name) table.remove(MyAddon.db.profile.wishlist.items, i) GameTooltip:Hide() ItemList(wishframe, container) end)
		itemList:SetCallback("OnEnter", function(itemList) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(v.name) end)
		itemList:SetCallback("OnLeave", function(itemList) GameTooltip:Hide() end)
		scrollList:AddChild(itemList)

		local itemSpacer = AceGUI:Create("Label")
		itemSpacer:SetText(v.use)
		scrollList:AddChild(itemSpacer)
	end
end

function RemoveUnderPrio()
	for i, v in ipairs(tablePrio) do
		if (v.prio < 5) then
			table.remove(tablePrio, i)
			RemoveUnderPrio()
			break			
		end
	end
end

function PriorityTable ()
	tablePrio = {}
	tablePrio = {
	{class = "Death Knight", spec = "Blood", mainstat = "Stamina", mastery = 2, critical = 0, haste = 0, hit = 1, expertise = 1, spirit = 0, dodge = 1, parry = 1, prio = 0},
	{class = "Death Knight", spec = "Frost", mainstat = "Strength", mastery = 1, critical = 0, haste = 2, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Death Knight", spec = "Unholy", mainstat = "Strength", mastery = 0, critical = 1, haste = 2, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},

	{class = "Druid", spec = "Balance", mainstat = "Intellect", mastery = 0, critical = 1, haste = 2, hit = 1, expertise = 0, spirit = 1, dodge = 0, parry = 0, prio = 0},
	{class = "Druid", spec = "Restoration", mainstat = "Intellect", mastery = 1, critical = 0, haste = 2, hit = 0, expertise = 0, spirit = 2, dodge = 0, parry = 0, prio = 0},
	{class = "Druid", spec = "Feral", mainstat = "Agility", mastery = 2, critical = 1, haste = 0, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Druid", spec = "Guardian", mainstat = "Stamina", mastery = 2, critical = 1, haste = 0, hit = 1, expertise = 1, spirit = 0, dodge = 2, parry = 0, prio = 0},
	
	{class = "Hunter", spec = "Marksman", mainstat = "Agility", mastery = 0, critical = 1, haste = 2, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Hunter", spec = "Beast Mastery", mainstat = "Agility", mastery = 2, critical = 1, haste = 0, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Hunter", spec = "Survival", mainstat = "Agility", mastery = 0, critical = 2, haste = 1, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	
	{class = "Mage", spec = "Fire", mainstat = "Intellect", mastery = 1, critical = 2, haste = 1, hit = 1, expertise = 0, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Mage", spec = "Frost", mainstat = "Intellect", mastery = 0, critical = 1, haste = 2, hit = 1, expertise = 0, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Mage", spec = "Arcane", mainstat = "Intellect", mastery = 2, critical = 0, haste = 1, hit = 1, expertise = 0, spirit = 0, dodge = 0, parry = 0, prio = 0},
	
	{class = "Monk", spec = "Brewmaster", mainstat = "Stamina", mastery = 0, critical = 1, haste = 2, hit = 1, expertise = 1, spirit = 0, dodge = 1, parry = 1, prio = 0},
	{class = "Monk", spec = "Mistweaver", mainstat = "Intellect", mastery = 1, critical = 0, haste = 2, hit = 0, expertise = 0, spirit = 2, dodge = 0, parry = 0, prio = 0},
	{class = "Monk", spec = "Windwalker", mainstat = "Agility", mastery = 0, critical = 1, haste = 2, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},

	{class = "Paladin", spec = "Protection", mainstat = "Stamina", mastery = 2, critical = 0, haste = 0, hit = 1, expertise = 1, spirit = 0, dodge = 1, parry = 1, prio = 0},
	{class = "Paladin", spec = "Holy", mainstat = "Intellect", mastery = 2, critical = 0, haste = 1, hit = 0, expertise = 0, spirit = 2, dodge = 0, parry = 0, prio = 0},
	{class = "Paladin", spec = "Retribution", mainstat = "Strength", mastery = 1, critical = 0, haste = 2, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	
	{class = "Priest", spec = "Discipline", mainstat = "Intellect", mastery = 2, critical = 1, haste = 1, hit = 0, expertise = 0, spirit = 2, dodge = 0, parry = 0, prio = 0},
	{class = "Priest", spec = "Shadow", mainstat = "Intellect", mastery = 0, critical = 1, haste = 2, hit = 1, expertise = 0, spirit = 1, dodge = 0, parry = 0, prio = 0},
	{class = "Priest", spec = "Holy", mainstat = "Intellect", mastery = 1, critical = 0, haste = 2, hit = 0, expertise = 0, spirit = 2, dodge = 0, parry = 0, prio = 0},
	
	{class = "Rogue", spec = "Subtlety", mainstat = "Agility", mastery = 0, critical = 1, haste = 2, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Rogue", spec = "Combat", mainstat = "Agility", mastery = 1, critical = 0, haste = 2, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Rogue", spec = "Assassination", mainstat = "Agility", mastery = 2, critical = 1, haste = 0, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	
	{class = "Shaman", spec = "Enhancement", mainstat = "Agility", mastery = 2, critical = 1, haste = 1, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Shaman", spec = "Elemental", mainstat = "Intellect", mastery = 1, critical = 0, haste = 2, hit = 1, expertise = 0, spirit = 1, dodge = 0, parry = 0, prio = 0},
	{class = "Shaman", spec = "Restoration", mainstat = "Intellect", mastery = 1, critical = 0, haste = 2, hit = 0, expertise = 0, spirit = 2, dodge = 0, parry = 0, prio = 0},
	
	{class = "Warlock", spec = "Demonology", mainstat = "Intellect", mastery = 1, critical = 2, haste = 1, hit = 1, expertise = 0, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Warlock", spec = "Affliction", mainstat = "Intellect", mastery = 2, critical = 0, haste = 1, hit = 1, expertise = 0, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Warlock", spec = "Destruction", mainstat = "Intellect", mastery = 1, critical = 2, haste = 1, hit = 1, expertise = 0, spirit = 0, dodge = 0, parry = 0, prio = 0},

	{class = "Warrior", spec = "Arms", mainstat = "Strength", mastery = 1, critical = 2, haste = 0, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0},
	{class = "Warrior", spec = "Protection", mainstat = "Stamina", mastery = 2, critical = 0, haste = 0, hit = 1, expertise = 1, spirit = 0, dodge = 1, parry = 1, prio = 0},
	{class = "Warrior", spec = "Fury", mainstat = "Strength", mastery = 1, critical = 2, haste = 0, hit = 1, expertise = 1, spirit = 0, dodge = 0, parry = 0, prio = 0}
	}
end